Index: otr.h
===================================================================
--- otr.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
+++ otr.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -0,0 +1,117 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2008 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/*
+  OTR support (cf. http://www.cypherpunks.ca/otr/)
+  
+  2008, Sven Moritz Hallberg <pesco@khjk.org>
+  (c) and funded by stonedcoder.org
+*/
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef BITLBEE_PROTOCOLS_OTR_H
+#define BITLBEE_PROTOCOLS_OTR_H
+
+#include "bitlbee.h"
+
+
+// forward decls to avoid mutual dependencies
+struct irc;
+struct im_connection;
+struct account;
+
+// 'otr' root command, hooked up in root_commands.c
+void cmd_otr(struct irc *, char **args);
+
+
+#ifdef WITH_OTR
+#include <libotr/proto.h>
+#include <libotr/message.h>
+#include <libotr/privkey.h>
+
+/* representing a keygen job */
+typedef struct kg {
+	char *accountname;
+	char *protocol;
+	
+	struct kg *next;
+} kg_t;
+
+/* struct to encapsulate our book keeping stuff */
+typedef struct otr {
+	OtrlUserState us;
+	pid_t keygen;    /* pid of keygen slave (0 if none) */
+	FILE *to;        /* pipe to keygen slave */
+	FILE *from;      /* pipe from keygen slave */
+	
+	/* active keygen job (NULL if none) */
+	char *sent_accountname;
+	char *sent_protocol;
+	
+	/* keygen jobs waiting to be sent to slave */
+	kg_t *todo;
+} otr_t;
+
+/* called from main() */
+void otr_init(void);
+
+/* called from irc_new()/irc_free() */
+otr_t *otr_new();
+void otr_free(otr_t *otr);
+
+/* called by storage_* functions */
+void otr_load(struct irc *irc);
+void otr_save(struct irc *irc);
+void otr_remove(const char *nick);
+void otr_rename(const char *onick, const char *nnick);
+
+/* called from account_add() */
+int otr_check_for_key(struct account *a);
+
+/* called from imcb_buddy_msg() */
+char *otr_handle_message(struct im_connection *ic, const char *handle,
+	const char *msg);
+	
+/* called from imc_buddy_msg() */
+int otr_send_message(struct im_connection *ic, const char *handle, const char *msg,
+	int flags);
+
+#else
+
+typedef void otr_t;
+typedef void *OtrlMessageAppOps;
+
+#define otr_init() {}
+#define otr_new() (NULL)
+#define otr_free(otr) {}
+#define otr_load(irc) {}
+#define otr_save(irc) {}
+#define otr_remove(nick) {}
+#define otr_rename(onick,nnick) {}
+#define otr_check_for_key(acc) (0)
+#define otr_handle_message(ic,handle,msg) (g_strdup(msg))
+#define otr_send_message(ic,h,m,f) (ic->acc->prpl->buddy_msg(ic,h,m,f))
+
+void cmd_otr_nosupport(void *, char **);
+
+#endif
+#endif
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/jabber/jabber.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -526,4 +526,5 @@
 	
 	ret->name = "jabber";
+    ret->mms = 0;                        /* no limit */
 	ret->login = jabber_login;
 	ret->init = jabber_init;
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/msn/msn.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -307,4 +307,5 @@
 	
 	ret->name = "msn";
+    ret->mms = 1409;         /* this guess taken from libotr UPGRADING file */
 	ret->login = msn_login;
 	ret->init = msn_init;
Index: protocols/msn/ns.c
===================================================================
--- protocols/msn/ns.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/msn/ns.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -271,23 +271,9 @@
 		if( num_parts == 5 )
 		{
-			int i, groupcount;
-			
-			groupcount = atoi( cmd[4] );
-			if( groupcount > 0 )
-			{
-				/* valgrind says this is leaking memory, I'm guessing
-				   that this happens during server redirects. */
-				if( md->grouplist )
-				{
-					for( i = 0; i < md->groupcount; i ++ )
-						g_free( md->grouplist[i] );
-					g_free( md->grouplist );
-				}
-				
-				md->groupcount = groupcount;
+			md->buddycount = atoi( cmd[3] );
+			md->groupcount = atoi( cmd[4] );
+			if( md->groupcount > 0 )
 				md->grouplist = g_new0( char *, md->groupcount );
-			}
-			
-			md->buddycount = atoi( cmd[3] );
+			
 			if( !*cmd[3] || md->buddycount == 0 )
 				msn_logged_in( ic );
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/nogaim.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -725,6 +725,8 @@
 	}
 	
-	/* early if-clause for show_offline even if there is some redundant code here because this isn't LISP but C ;) */
-	if( set_getbool( &ic->irc->set, "show_offline" ) && set_getbool( &ic->irc->set, "away_devoice" ) )
+	/* LISPy... */
+	if( ( u->online ) &&						/* Don't touch offline people */
+	    ( ( u->online != oo ) ||					/* Do joining people */
+	      ( ( u->online == oo ) && ( oa == !u->away ) ) ) )		/* Do people changing state */
 	{
 		char *from;
@@ -740,40 +742,28 @@
 		}
 
-		/* if we use show_offline, we op online users, voice away users, and devoice/deop offline users */
-		if( flags & OPT_LOGGED_IN )
-		{
-			/* user is "online" (either really online or away) */
-			irc_write( ic->irc, ":%s MODE %s %cv%co %s %s", from, ic->irc->channel,
-			                                          u->away?'+':'-', u->away?'-':'+', u->nick, u->nick );
-		}
-		else
-		{
-			/* user is offline */
-			irc_write( ic->irc, ":%s MODE %s -vo %s %s", from, ic->irc->channel, u->nick, u->nick );
-		}
-	}
-	else
-	{ 
-		/* LISPy... */
-		if( ( set_getbool( &ic->irc->set, "away_devoice" ) ) &&		/* Don't do a thing when user doesn't want it */
-		    ( u->online ) &&						/* Don't touch offline people */
-		    ( ( ( u->online != oo ) && !u->away ) ||			/* Voice joining people */
-		      ( ( u->online == oo ) && ( oa == !u->away ) ) ) )		/* (De)voice people changing state */
-		{
-			char *from;
-
-			if( set_getbool( &ic->irc->set, "simulate_netsplit" ) )
-			{
-				from = g_strdup( ic->irc->myhost );
-			}
-			else
-			{
-				from = g_strdup_printf( "%s!%s@%s", ic->irc->mynick, ic->irc->mynick,
-				                                    ic->irc->myhost );
-			}
+		if(!strcmp(set_getstr(&ic->irc->set, "voice_buddies"), "online")) {
+			irc_write( ic->irc, ":%s MODE %s +v %s", from, ic->irc->channel, u->nick );
+		}
+		if(!strcmp(set_getstr(&ic->irc->set, "halfop_buddies"), "online")) {
+			irc_write( ic->irc, ":%s MODE %s +h %s", from, ic->irc->channel, u->nick );
+		}
+		if(!strcmp(set_getstr(&ic->irc->set, "op_buddies"), "online")) {
+			irc_write( ic->irc, ":%s MODE %s +o %s", from, ic->irc->channel, u->nick );
+		}
+
+		if(!strcmp(set_getstr(&ic->irc->set, "voice_buddies"), "notaway")) {
 			irc_write( ic->irc, ":%s MODE %s %cv %s", from, ic->irc->channel,
-			                                          u->away?'-':'+', u->nick );
-			g_free( from );
-		}
+		 	                                         u->away?'-':'+', u->nick );
+		}
+		if(!strcmp(set_getstr(&ic->irc->set, "halfop_buddies"), "notaway")) {
+			irc_write( ic->irc, ":%s MODE %s %ch %s", from, ic->irc->channel,
+		 	                                         u->away?'-':'+', u->nick );
+		}
+		if(!strcmp(set_getstr(&ic->irc->set, "op_buddies"), "notaway")) {
+			irc_write( ic->irc, ":%s MODE %s %co %s", from, ic->irc->channel,
+		 	                                         u->away?'-':'+', u->nick );
+		}
+
+		g_free( from );
 	}
 }
@@ -784,7 +774,13 @@
 	char *wrapped, *ts = NULL;
 	user_t *u;
-	
+
+	/* pass the message through OTR */
+	msg = otr_handle_message(ic, handle, msg);
+	if(!msg) {
+		/* this was an internal OTR protocol message */
+		return;
+	}
+
 	u = user_findhandle( ic, handle );
-	
 	if( !u )
 	{
@@ -796,4 +792,5 @@
 				imcb_log( ic, "Ignoring message from unknown handle %s", handle );
 			
+			g_free(msg);
 			return;
 		}
@@ -829,6 +826,6 @@
 	{
 		char *new = g_strconcat( ts, msg, NULL );
-		g_free( ts );
-		ts = msg = new;
+		g_free( msg );
+		msg = new;
 	}
 	
@@ -836,4 +833,5 @@
 	irc_msgfrom( irc, u->nick, wrapped );
 	g_free( wrapped );
+	g_free( msg );
 	g_free( ts );
 }
@@ -1112,59 +1110,4 @@
 /* Misc. BitlBee stuff which shouldn't really be here */
 
-char *set_eval_away_devoice( set_t *set, char *value )
-{
-	irc_t *irc = set->data;
-	int st;
-	
-	if( !is_bool( value ) )
-		return SET_INVALID;
-	
-	st = bool2int( value );
-	
-	/* Horror.... */
-	
-	if( st != set_getbool( &irc->set, "away_devoice" ) )
-	{
-		char list[80] = "";
-		user_t *u = irc->users;
-		int i = 0, count = 0;
-		char pm;
-		char v[80];
-		
-		if( st )
-			pm = '+';
-		else
-			pm = '-';
-		
-		while( u )
-		{
-			if( u->ic && u->online && !u->away )
-			{
-				if( ( strlen( list ) + strlen( u->nick ) ) >= 79 )
-				{
-					for( i = 0; i < count; v[i++] = 'v' ); v[i] = 0;
-					irc_write( irc, ":%s MODE %s %c%s%s",
-					           irc->myhost,
-		        			   irc->channel, pm, v, list );
-					
-					*list = 0;
-					count = 0;
-				}
-				
-				sprintf( list + strlen( list ), " %s", u->nick );
-				count ++;
-			}
-			u = u->next;
-		}
-		
-		/* $v = 'v' x $i */
-		for( i = 0; i < count; v[i++] = 'v' ); v[i] = 0;
-		irc_write( irc, ":%s MODE %s %c%s%s", irc->myhost,
-		                                            irc->channel, pm, v, list );
-	}
-	
-	return value;
-}
-
 char *set_eval_timezone( set_t *set, char *value )
 {
@@ -1269,8 +1212,9 @@
 		msg = buf;
 	}
-	
-	st = ic->acc->prpl->buddy_msg( ic, handle, msg, flags );
-	g_free( buf );
-	
+
+	/* if compiled without otr support, this just calls the prpl buddy_msg */
+	st = otr_send_message(ic, handle, msg, flags);
+	
+	g_free(buf);
 	return st;
 }
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/nogaim.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -59,4 +59,5 @@
 #define OPT_TYPING      0x00000100 /* Some pieces of code make assumptions */
 #define OPT_THINKING    0x00000200 /* about these values... Stupid me! */
+#define OPT_NOOTR	0x00001000 /* protocol not suitable for OTR */
 
 /* ok. now the fun begins. first we create a connection structure */
@@ -132,4 +133,8 @@
 	 * - The user sees this name ie. when imcb_log() is used. */
 	const char *name;
+	/* Maximum Message Size of this protocol.
+	 * - Introduced for OTR, in order to fragment large protocol messages.
+	 * - 0 means "unlimited". */
+	unsigned int mms;
 
 	/* Added this one to be able to add per-account settings, don't think
@@ -326,5 +331,4 @@
 /* Misc. stuff */
 char *set_eval_timezone( set_t *set, char *value );
-char *set_eval_away_devoice( set_t *set, char *value );
 gboolean auto_reconnect( gpointer data, gint fd, b_input_condition cond );
 void cancel_auto_reconnect( struct account *a );
Index: protocols/oscar/oscar.c
===================================================================
--- protocols/oscar/oscar.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/oscar/oscar.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -2554,4 +2554,5 @@
 	struct prpl *ret = g_new0(struct prpl, 1);
 	ret->name = "oscar";
+    ret->mms = 2343;       /* this guess taken from libotr UPGRADING file */
 	ret->away_states = oscar_away_states;
 	ret->init = oscar_init;
Index: protocols/twitter/twitter.c
===================================================================
--- protocols/twitter/twitter.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/twitter/twitter.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -356,4 +356,5 @@
 	struct prpl *ret = g_new0(struct prpl, 1);
 	
+	ret->options = OPT_NOOTR;
 	ret->name = "twitter";
 	ret->login = twitter_login;
Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/yahoo/libyahoo2.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -69,4 +69,6 @@
 #ifdef __MINGW32__
 # include <winsock2.h>
+# define write(a,b,c) send(a,b,c,0)
+# define read(a,b,c)  recv(a,b,c,0)
 #endif
 
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/yahoo/yahoo.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -355,4 +355,5 @@
 	struct prpl *ret = g_new0(struct prpl, 1);
 	ret->name = "yahoo";
+    ret->mms = 832;           /* this guess taken from libotr UPGRADING file */
 	ret->init = byahoo_init;
 	
Index: protocols/yahoo/yahoo_httplib.c
===================================================================
--- protocols/yahoo/yahoo_httplib.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ protocols/yahoo/yahoo_httplib.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -51,4 +51,6 @@
 #ifdef __MINGW32__
 # include <winsock2.h>
+# define write(a,b,c) send(a,b,c,0)
+# define read(a,b,c)  recv(a,b,c,0)
 # define snprintf _snprintf
 #endif
Index: query.c
===================================================================
--- query.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ query.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -103,4 +103,7 @@
 	int count = 0;
 	
+	if(!ic)
+		return;
+	
 	q = irc->queries;
 	def = query_default( irc );
@@ -145,5 +148,6 @@
 		else
 			irc_usermsg( irc, "Accepted: %s", q->question );
-		q->yes( q->data );
+		if( q->yes )
+			q->yes( q->data );
 	}
 	else
@@ -153,5 +157,6 @@
 		else
 			irc_usermsg( irc, "Rejected: %s", q->question );
-		q->no( q->data );
+		if( q->no )
+			q->no( q->data );
 	}
 	q->data = NULL;
Index: root_commands.c
===================================================================
--- root_commands.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ root_commands.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -29,4 +29,5 @@
 #include "bitlbee.h"
 #include "help.h"
+#include "otr.h"
 #include "chat.h"
 
@@ -414,4 +415,8 @@
 		
 		irc_usermsg( irc, "Account successfully added" );
+		
+		if(otr_check_for_key(a)) {
+			irc_usermsg(irc, "otr: you will be notified when it completes");
+		}
 	}
 	else if( g_strcasecmp( cmd[1], "del" ) == 0 )
@@ -1177,4 +1182,5 @@
 	{ "qlist",          0, cmd_qlist,          0 },
 	{ "join_chat",      2, cmd_join_chat,      0 },
+	{ "otr",            1, cmd_otr,            0 },	
 	{ "chat",           1, cmd_chat,           0 },
 	{ NULL }
Index: set.c
===================================================================
--- set.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ set.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -225,23 +225,166 @@
 }
 
-char *set_eval_ops( set_t *set, char *value )
+char* set_eval_op_root( set_t *set, char* value )
 {
 	irc_t *irc = set->data;
-	
-	if( g_strcasecmp( value, "user" ) == 0 )
-		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
-		                                              irc->channel, "+o-o", irc->nick, irc->mynick );
-	else if( g_strcasecmp( value, "root" ) == 0 )
-		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
-		                                              irc->channel, "-o+o", irc->nick, irc->mynick );
-	else if( g_strcasecmp( value, "both" ) == 0 )
-		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
-		                                              irc->channel, "+oo", irc->nick, irc->mynick );
-	else if( g_strcasecmp( value, "none" ) == 0 )
-		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
-		                                              irc->channel, "-oo", irc->nick, irc->mynick );
+	char* ret = set_eval_bool(set, value);
+	int b = bool2int(ret);
+
+	irc_write( irc, ":%s!%s@%s MODE %s %s %s", irc->mynick, irc->mynick, irc->myhost,
+                                               irc->channel, b?"+o":"-o", irc->mynick);
+
+	return ret;
+}
+
+char* set_eval_op_user( set_t *set, char* value )
+{
+	irc_t *irc = set->data;
+	char* ret = set_eval_bool(set, value);
+	int b = bool2int(ret);
+
+	irc_write( irc, ":%s!%s@%s MODE %s %s %s", irc->mynick, irc->mynick, irc->myhost,
+                                               irc->channel, b?"+o":"-o", irc->nick);
+
+	return ret;
+}
+
+/* generalized version of set_eval_op/voice_buddies */
+char *set_eval_mode_buddies( set_t *set, char *value, char modeflag )
+{
+	irc_t *irc = set->data;
+	char op[64], deop[64];
+	int nop=0, ndeop=0;
+	user_t *u;
+	int mode;
+	
+	if(!strcmp(value, "false"))
+		mode=0;
+	else if(!strcmp(value, "encrypted"))
+		mode=1;
+	else if(!strcmp(value, "trusted"))
+		mode=2;
+	else if(!strcmp(value, "notaway"))
+		mode=3;
 	else
 		return SET_INVALID;
-	
+
+	/* sorry for calling them op/deop - too lazy for search+replace :P */
+	op[0]='\0';
+	deop[0]='\0';
+	for(u=irc->users; u; u=u->next) {
+		/* we're only concerned with online buddies */
+		if(!u->ic || !u->online)
+			continue;
+
+		/* just in case... */
+		if(strlen(u->nick) >= 64)
+			continue;
+		
+		/* dump out ops/deops when the corresponding name list fills up */
+		if(strlen(op)+strlen(u->nick)+2 > 64) {
+			char *flags = g_strnfill(nop, modeflag);
+			irc_write( irc, ":%s!%s@%s MODE %s +%s%s", irc->mynick, irc->mynick, irc->myhost,
+		                                               irc->channel, flags, op );
+		    op[0]='\0';
+            nop=0;
+		    g_free(flags);
+		}
+		if(strlen(deop)+strlen(u->nick)+2 > 64) {
+			char *flags = g_strnfill(ndeop, modeflag);
+			irc_write( irc, ":%s!%s@%s MODE %s -%s%s", irc->mynick, irc->mynick, irc->myhost,
+		                                               irc->channel, flags, deop );
+		    deop[0]='\0';
+            ndeop=0;
+		    g_free(flags);
+		}
+		
+		switch(mode) {
+		/* "false" */
+		case 0:
+			g_strlcat(deop, " ", 64);
+			g_strlcat(deop, u->nick, 64);
+			ndeop++;
+			break;
+		/* "encrypted" */
+		case 1:
+			if(u->encrypted) {
+				g_strlcat(op, " ", 64);
+				g_strlcat(op, u->nick, 64);
+				nop++;
+			} else {
+				g_strlcat(deop, " ", 64);
+				g_strlcat(deop, u->nick, 64);
+				ndeop++;
+			}
+			break;
+		/* "trusted" */
+		case 2:
+			if(u->encrypted > 1) {
+				g_strlcat(op, " ", 64);
+				g_strlcat(op, u->nick, 64);
+				nop++;
+			} else {
+				g_strlcat(deop, " ", 64);
+				g_strlcat(deop, u->nick, 64);
+				ndeop++;
+			}
+			break;
+		/* "notaway" */
+		case 3:
+			if(u->away) {
+				g_strlcat(deop, " ", 64);
+				g_strlcat(deop, u->nick, 64);
+				ndeop++;
+			} else {
+				g_strlcat(op, " ", 64);
+				g_strlcat(op, u->nick, 64);
+				nop++;
+			}
+		}
+	}
+	/* dump anything left in op/deop lists */
+	if(*op) {
+		char *flags = g_strnfill(nop, modeflag);
+		irc_write( irc, ":%s!%s@%s MODE %s +%s%s", irc->mynick, irc->mynick, irc->myhost,
+		                                               irc->channel, flags, op );
+		g_free(flags);
+	}
+	if(*deop) {
+		char *flags = g_strnfill(ndeop, modeflag);
+		irc_write( irc, ":%s!%s@%s MODE %s -%s%s", irc->mynick, irc->mynick, irc->myhost,
+                                                   irc->channel, flags, deop );
+        g_free(flags);
+    }
+
 	return value;
 }
+
+char *set_eval_op_buddies( set_t *set, char *value )
+{
+	return set_eval_mode_buddies(set, value, 'o');
+}
+
+char *set_eval_halfop_buddies( set_t *set, char *value )
+{
+	return set_eval_mode_buddies(set, value, 'h');
+}
+
+char *set_eval_voice_buddies( set_t *set, char *value )
+{
+	return set_eval_mode_buddies(set, value, 'v');
+}
+
+/* possible values: never, opportunistic, manual, always */
+char *set_eval_otr_policy( set_t *set, char *value )
+{
+	if ( !strcmp(value, "never") )
+		return value;
+	if ( !strcmp(value, "opportunistic") )
+		return value;
+	if ( !strcmp(value, "manual") )
+		return value;
+	if ( !strcmp(value, "always") )
+		return value;
+	return NULL;
+}
+
Index: set.h
===================================================================
--- set.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ set.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -100,5 +100,10 @@
 /* Some not very generic evaluators that really shouldn't be here... */
 char *set_eval_to_char( set_t *set, char *value );
-char *set_eval_ops( set_t *set, char *value );
+char *set_eval_op_root( set_t *set, char *value );
+char *set_eval_op_user( set_t *set, char *value );
+char *set_eval_op_buddies( set_t *set, char *value );
+char *set_eval_halfop_buddies( set_t *set, char *value );
+char *set_eval_voice_buddies( set_t *set, char *value );
+char *set_eval_otr_policy( set_t *set, char *value );
 
 #endif /* __SET_H__ */
Index: sock.h
===================================================================
--- sock.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ sock.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -16,9 +16,15 @@
 #else
 # include <winsock2.h>
-# include <ws2tcpip.h>
+# ifndef _MSC_VER
+#  include <ws2tcpip.h>
+# endif
 # if !defined(BITLBEE_CORE) && defined(_MSC_VER)
 #   pragma comment(lib,"bitlbee.lib")
 # endif
 # include <io.h>
+# define read(a,b,c) recv(a,b,c,0)
+# define write(a,b,c) send(a,b,c,0)
+# define umask _umask
+# define mode_t int
 # define sock_make_nonblocking(fd) { int non_block = 1; ioctlsocket(fd, FIONBIO, &non_block); }
 # define sock_make_blocking(fd) { int non_block = 0; ioctlsocket(fd, FIONBIO, &non_block); }
Index: storage.c
===================================================================
--- storage.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ storage.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -29,4 +29,5 @@
 #include "bitlbee.h"
 #include "crypting.h"
+#include "otr.h"
 
 extern storage_t storage_text;
@@ -116,7 +117,8 @@
 
 		status = st->load(irc, password);
-		if (status == STORAGE_OK)
+		if (status == STORAGE_OK) {
+			otr_load(irc);
 			return status;
-		
+		}
 		if (status != STORAGE_NO_SUCH_USER) 
 			return status;
@@ -139,5 +141,6 @@
 		return STORAGE_NO_SUCH_USER;
 	}
-	
+
+	otr_save(irc);
 	st = ((storage_t *)global.storage->data)->save(irc, overwrite);
 	
@@ -165,4 +168,7 @@
 			ret = status;
 	}
+	if (ret == STORAGE_OK) {
+		otr_remove(nick);
+	}
 	
 	return ret;
@@ -178,10 +184,12 @@
 	storage_t *primary_storage = gl->data;
 	irc_t *irc;
-
+	
 	/* First, try to rename in the current write backend, assuming onick 
 	 * is stored there */
 	status = primary_storage->rename(onick, nnick, password);
-	if (status != STORAGE_NO_SUCH_USER)
+	if (status != STORAGE_NO_SUCH_USER) {
+		otr_rename(onick, nnick);
 		return status;
+	}
 
 	/* Try to load from a migration backend and save to the current backend. 
@@ -207,4 +215,5 @@
 
 	storage_remove(onick, password);
+	otr_rename(onick, nnick);
 
 	return STORAGE_OK;
Index: storage_text.c
===================================================================
--- storage_text.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ storage_text.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -27,12 +27,4 @@
 #include "bitlbee.h"
 #include "crypting.h"
-#ifdef _WIN32
-# define umask _umask
-# define mode_t int
-#endif
-
-#ifndef F_OK
-#define F_OK 0
-#endif
 
 static void text_init (void)
Index: unix.c
===================================================================
--- unix.c	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ unix.c	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -29,7 +29,10 @@
 #include "base64.h"
 #include "commands.h"
+#include "crypting.h"
+#include "otr.h"
 #include "protocols/nogaim.h"
 #include "help.h"
 #include "ipc.h"
+#include "lib/ssl_client.h"
 #include "md5.h"
 #include "misc.h"
@@ -63,4 +66,11 @@
 	b_main_init();
 	nogaim_init();
+ 	/* Ugly Note: libotr and gnutls both use libgcrypt. libgcrypt
+ 	   has a process-global config state whose initialization happpens
+ 	   twice if libotr and gnutls are used together. libotr installs custom
+ 	   memory management functions for libgcrypt while our gnutls module
+ 	   uses the defaults. Therefore we initialize OTR after SSL. *sigh* */
+ 	ssl_init();
+ 	otr_init();
 	
 	srand( time( NULL ) ^ getpid() );
Index: user.h
===================================================================
--- user.h	(revision 3dc6d86076dbea16c313bb87aa2f37166f289a8e)
+++ user.h	(revision 37598495deeb42e1cd216a0a4ba8068e4a6da453)
@@ -38,4 +38,5 @@
 	char is_private;
 	char online;
+	char encrypted;
 	
 	char *handle;
